<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\UsersModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;
use App\Http\Controllers\Providers\IAM\Core\AuthManager\PasswordHashes;

class UsersService extends BaseService
{
    /**
     * UsersService constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->model = new UsersModel();
        $this->passwordHashes = new PasswordHashes();
    }

    /**
     *  index function that get all data from database by default
     * @return array|static[]
     */
    public function index()
    {
        return $this->model->getQuery()->get();
    }


    /**
     *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
     * @param array $input
     * @return array
     */
    public function paging($request)
    {
        $auth = json_decode($request->session()->get('auth'));
        
        $this->model->joinRelationRoleId()->joinRelationKapalId()->getQuery()->select(["users.id as id",
            "roleId.roleName as roleName",
            "kapalId.kodeKapal as kodeKapal",
            "kapalId.namaKapal as namaKapal",
            "users.kapalId as kapalId",
            "users.name as name",
            "users.aktif",
            "users.nrp",
            "users.jabatan",
            "users.username as username"]);
        $input = $request->all();
        if(! isset($input["sort"])) {
            $this->model->getQuery()->orderBy("users.date_updated", "desc");
        }

        if($auth->aplikasi != "HO") { 
            $this->model->getQuery()->where("users.kapalId", "=", $auth->kapalId); 
        }
        $this->model->paging()->filter()->sorting();
        return $this->model->paging()->getPaging();
    }

    /**
     *  get one raw row data from table by id
     *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
     *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
     *  and you want to take value like this $model->fieldname
     * @param $id
     * @return UsersModel
     */
    public function show($id)
    {
        $model = (new UsersModel())->joinRelationRoleId()->joinRelationKapalId()->getQuery()
                ->select([
                        "users.id as id",
                        "users.roleId as roleId",
                        "users.kapalId as kapalId",
                        "users.jabatan as jabatan",
                        "users.nrp as nrp",
                        "roleId.roleName as roleName",
                        "kapalId.kodeKapal as kodeKapal",
                        "kapalId.namaKapal as namaKapal",
                        "users.lokasiId as lokasiId",
                        "users.name as name",
                        "users.aplikasi as aplikasi",
                        "users.username as username"
                ])
                ->where("users.id", "=", $id)->first();
        return $model;
    }


    /**
     *  this is a base function for storing data you with transaction by default
     *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
     * @param array $input
     * @return UsersModel
     * @throws \Exception
     */
    public function store($input)
    {
        $input["lokasiId"] = "";
        $input["password"] = $this->passwordHashes->hashingPassword($input["password"]);
        if(isset($input["locations"])) { $input["lokasiId"] = implode(",", $input["locations"]); }
        
        $transaction = new UsersModel();
		$transaction->fill($input);			
		if(! $transaction->save()){
			throw new \Exception();
		}
		return $transaction->id;
    }


    /**
     * this function will delete much data, in one action
     * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
     * you can remove this main alogorithm with your business requirement like soft delete or anything you want
     * @param $ids
     */
    public function delete($ids)
    {
        $params = explode(".", $ids);
        $this->model->deleteBulk("id", $params);
    }


    /**
     *  this is a base function for update and delete data by default.
     *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or
     *  you can add multiple relation proses after update in this function
     * @param $id
     * @param array $input
     * @return UsersModel
     * @throws \Exception
     */
    public function update($id, $input)
    {
        $input["lokasiId"] = "";
        $input["date_updated"] = date("Y-m-d H:i:s");
        if(isset($input["locations"])) { $input["lokasiId"] = implode(",", $input["locations"]); }
        $users = UsersModel::find($id);
        $users->fill($input);
        if (!$users->update()) {
            throw new \Exception();
        }
        return $users;
    }


    /**
     *  this function will be confirting paging property into file excel
     *  the main library is base on excel spreadsheet library
     * @param array $input
     * @return array|static[]
     */
    public function exportToExcel($input = array())
    {
        return $this->model->getQuery()->get();
    }

    public function updatePassword($id, $input)
    {       
        $newPassword["password"] = $this->passwordHashes->hashingPassword($input["password"]);
        $users = UsersModel::find($id);
        $users->fill($newPassword);
        if (! $users->update() ) {
            throw new \Exception();
        }
        return $users;
    }

    public function getNahkodaProfile($kapalId, $jabatan="Nahkoda")
    {
        $model = (new UsersModel())->joinRelationRoleId()->joinRelationKapalId()->getQuery()
                ->select([
                        "users.id as id",
                        "users.roleId as roleId",
                        "users.kapalId as kapalId",
                        "users.jabatan as jabatan",
                        "users.nrp as nrp",
                        "roleId.roleName as roleName",
                        "kapalId.kodeKapal as kodeKapal",
                        "kapalId.namaKapal as namaKapal",
                        "users.lokasiId as lokasiId",
                        "users.name as name",
                        "users.aplikasi as aplikasi",
                        "users.username as username"
                ])
                ->where("users.kapalId", "=", $kapalId)
                ->where("jabatan", "ILIKE", "%" . $jabatan . "%")
                ->first();
        return $model;
    }

    public function activation($activateCode, $userID)
    {       
        $activation["aktif"] = $activateCode;
        $users = UsersModel::find($userID);
        $users->fill($activation);
        if (! $users->update() ) {
            throw new \Exception();
        }
        return $users;
    }

}